diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/theme.c metacity-2.27.1/src/ui/theme.c
--- ../metacity-2.27.1/src/ui/theme.c	2009-09-14 09:05:19.281164238 +0200
+++ metacity-2.27.1/src/ui/theme.c	2009-09-14 09:05:34.535572803 +0200
@@ -61,6 +61,11 @@
 #include <string.h>
 #include <stdlib.h>
 #include <math.h>
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
+#endif
 
 #define GDK_COLOR_RGBA(color)                                           \
                          ((guint32) (0xff                         |     \
@@ -622,7 +627,12 @@ meta_frame_layout_calc_geometry (const M
 
   fgeom->width = width;
   fgeom->height = height;
-
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  if (tsol_is_available ())
+    fgeom->height = height + fgeom->top_height; /*Trusted Frame Layout Modification TFLM*/
+#endif  
+#endif  
   fgeom->top_titlebar_edge = layout->title_border.top;
   fgeom->bottom_titlebar_edge = layout->title_border.bottom;
   fgeom->left_titlebar_edge = layout->left_titlebar_edge;
@@ -1064,7 +1074,13 @@ meta_color_spec_new (MetaColorSpecType t
     case META_COLOR_SPEC_BASIC:
       size += sizeof (dummy.data.basic);
       break;
-
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL    
+    case META_COLOR_SPEC_LABEL:
+      size += sizeof (dummy.data.label);
+      break;
+#endif
+#endif
     case META_COLOR_SPEC_GTK:
       size += sizeof (dummy.data.gtk);
       break;
@@ -1095,7 +1111,13 @@ meta_color_spec_free (MetaColorSpec *spe
     case META_COLOR_SPEC_BASIC:
       DEBUG_FILL_STRUCT (&spec->data.basic);
       break;
-
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL      
+    case META_COLOR_SPEC_LABEL:
+      DEBUG_FILL_STRUCT (&spec->data.label);
+      break;
+#endif
+#endif
     case META_COLOR_SPEC_GTK:
       DEBUG_FILL_STRUCT (&spec->data.gtk);
       break;
@@ -1194,6 +1216,16 @@ meta_color_spec_new_from_string (const c
       g_assert (spec->data.gtk.state < N_GTK_STATES);
       g_assert (spec->data.gtk.component < META_GTK_COLOR_LAST);
     }
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  else if (str[0] == 'l' && str[1] == 'a' && str[2] == 'b' && str[3] == 'e' &&
+           str[4] == 'l')
+    {
+      spec = meta_color_spec_new (META_COLOR_SPEC_LABEL);
+      spec->data.label.dummy = TRUE;
+    }
+#endif  
+#endif  
   else if (str[0] == 'b' && str[1] == 'l' && str[2] == 'e' && str[3] == 'n' &&
            str[4] == 'd' && str[5] == '/')
     {
@@ -1369,7 +1401,21 @@ meta_color_spec_render (MetaColorSpec *s
     case META_COLOR_SPEC_BASIC:
       *color = spec->data.basic.color;
       break;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+    case META_COLOR_SPEC_LABEL:
+	{
+	  MetaTrustedLabel *label = NULL;
+	  label = (MetaTrustedLabel *)g_object_get_data (G_OBJECT (widget), "trusted_label");
+	  if (label != NULL)
+	    *color = label->color->data.basic.color;
+	  else
+	    g_warning ("trusted_label property isn't set for the widget");
 
+	}
+      break;
+#endif      
+#endif      
     case META_COLOR_SPEC_GTK:
       switch (spec->data.gtk.component)
         {
@@ -2188,6 +2234,14 @@ pos_eval_get_variable (PosToken         
         *result = env->title_width;
       else if (t->d.v.name_quark == env->theme->quark_title_height)
         *result = env->title_height;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+      else if (t->d.v.name_quark == env->theme->quark_trusted_label_width)
+        *result = env->trusted_label_width;
+      else if (t->d.v.name_quark == env->theme->quark_trusted_label_height)
+        *result = env->trusted_label_height;
+#endif
+#endif
       else
         {
           g_set_error (err, META_THEME_ERROR,
@@ -2229,6 +2283,14 @@ pos_eval_get_variable (PosToken         
         *result = env->title_width;
       else if (strcmp (t->d.v.name, "title_height") == 0)
         *result = env->title_height;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+      else if (strcmp (t->d.v.name, "trusted_label_width") == 0)
+        *result = env->trusted_label_width;
+      else if (strcmp (t->d.v.name, "trusted_label_height") == 0)
+        *result = env->trusted_label_height;
+#endif
+#endif
       else
         {
           g_set_error (err, META_THEME_ERROR,
@@ -2742,6 +2804,13 @@ meta_draw_op_new (MetaDrawType type)
     case META_DRAW_TILE:
       size += sizeof (dummy.data.tile);
       break;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+    case META_DRAW_TRUSTED_LABEL:
+      size += sizeof (dummy.data.trusted_label);
+      break;
+#endif      
+#endif      
     }
 
   op = g_malloc0 (size);
@@ -2901,6 +2970,16 @@ meta_draw_op_free (MetaDrawOp *op)
       meta_draw_spec_free (op->data.tile.tile_width);
       meta_draw_spec_free (op->data.tile.tile_height);
       break;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+    case META_DRAW_TRUSTED_LABEL:
+      if (op->data.trusted_label.color_spec)
+        meta_color_spec_free (op->data.trusted_label.color_spec);
+      g_free (op->data.trusted_label.x);
+      g_free (op->data.trusted_label.y);
+      break;
+#endif      
+#endif      
     }
 
   g_free (op);
@@ -3416,6 +3495,12 @@ draw_op_as_pixbuf (const MetaDrawOp    *
 
     case META_DRAW_TILE:
       break;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL      
+    case META_DRAW_TRUSTED_LABEL:
+      break;
+#endif      
+#endif      
     }
 
   return pixbuf;
@@ -3453,6 +3538,25 @@ fill_env (MetaPositionExprEnv *env,
 
   env->title_width = info->title_layout_width;
   env->title_height = info->title_layout_height;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  if (info->label && info->label->layout)
+    {
+      PangoRectangle extents;
+      
+      pango_layout_get_pixel_extents (info->label->layout,
+				      NULL, &extents);
+  
+      env->trusted_label_width =  extents.width;
+      env->trusted_label_height = extents.height;
+    }
+  else
+    {
+      env->trusted_label_width = 0;
+      env->trusted_label_height = 0;
+    }
+#endif  
+#endif  
   env->theme = meta_current_theme;
 }
 
@@ -3637,6 +3741,17 @@ meta_draw_op_draw_with_env (const MetaDr
           {
             env->object_width = gdk_pixbuf_get_width (op->data.image.pixbuf);
             env->object_height = gdk_pixbuf_get_height (op->data.image.pixbuf);
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL	    
+	    /* Hack to display shield icon conditionally  */
+	    if (op->data.image.pixbuf == shield_pixbuf)
+	      {
+		/* SUN_BRANDING TJDS */
+		if (strcmp (info->label->name, _("Trusted Path")) != 0)
+		  return;
+	      }
+#endif	    
+#endif	    
           }
 
         rwidth = parse_size_unchecked (op->data.image.width, env);
@@ -3823,6 +3938,54 @@ meta_draw_op_draw_with_env (const MetaDr
           }
       }
       break;
+      
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL      
+    case META_DRAW_TRUSTED_LABEL:
+      if (info->title_layout)
+        {
+          int rx, ry;
+	  int text_w, text_h;
+	  static MetaColorSpec *black = NULL;
+	  static MetaColorSpec *white = NULL;
+	  MetaColorSpec *color;
+	  gboolean black_text = tsol_should_label_layout_be_black (info->label->color);
+	  
+	  if (!black)
+	    {
+	      black = meta_color_spec_new (META_COLOR_SPEC_BASIC);
+	      white = meta_color_spec_new (META_COLOR_SPEC_BASIC);
+
+	      gdk_color_parse ("black", &black->data.basic.color);
+	      gdk_color_parse ("white", &white->data.basic.color);
+	    }
+
+	  if (black_text)
+	    {
+	      color = black;
+	    }
+	  else
+	    {
+	      color = white;
+	    }
+	  
+	  pango_layout_get_pixel_size (info->label->layout,&text_w, &text_h);
+
+	  rx = ((rect.width - text_w) / 2 ) + rect.x;
+	  ry = ((rect.height - text_h) / 2 ) + rect.y;
+
+	  gc = get_gc_for_primitive (widget, drawable, color, clip, 0);
+	  
+          gdk_draw_layout (drawable, gc,
+                           rx, ry,
+                           info->label->layout);
+          
+	  g_object_unref (G_OBJECT (gc));
+
+        }
+      break;
+#endif      
+#endif      
     }
 }
 
@@ -4302,6 +4465,11 @@ meta_frame_style_draw_with_style (MetaFr
                                   int                      client_width,
                                   int                      client_height,
                                   PangoLayout             *title_layout,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL			    
+				       MetaTrustedLabel	    *label,
+#endif			    
+#endif			
                                   int                      text_height,
                                   MetaButtonState          button_states[META_BUTTON_TYPE_LAST],
                                   GdkPixbuf               *mini_icon,
@@ -4369,6 +4537,19 @@ meta_frame_style_draw_with_style (MetaFr
   draw_info.title_layout_width = title_layout ? extents.width : 0;
   draw_info.title_layout_height = title_layout ? extents.height : 0;
   draw_info.fgeom = fgeom;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  if (tsol_is_available ())
+    {
+      draw_info.label = label;
+      if (!label->layout)
+	label->layout = gtk_widget_create_pango_layout (widget, label->name);
+      g_object_set_data (G_OBJECT (widget), "trusted_label", label);
+    }
+  else
+    draw_info.label = NULL;
+#endif  
+#endif  
   
   /* The enum is in the order the pieces should be rendered. */
   i = 0;
@@ -4386,6 +4567,16 @@ meta_frame_style_draw_with_style (MetaFr
           rect.height = fgeom->height;
           break;
 
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL 
+	case META_FRAME_PIECE_TRUSTED_LABEL:
+          rect.x = 0;
+          rect.y = fgeom->top_height;
+          rect.width = fgeom->width;
+          rect.height = fgeom->top_height;
+          break;
+#endif
+#endif
         case META_FRAME_PIECE_TITLEBAR:
           rect = titlebar_rect;
           break;
@@ -4552,6 +4743,11 @@ meta_frame_style_draw (MetaFrameStyle   
                        int                      client_width,
                        int                      client_height,
                        PangoLayout             *title_layout,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL		       
+		       MetaTrustedLabel	       *label,
+#endif		       
+#endif		       
                        int                      text_height,
                        MetaButtonState          button_states[META_BUTTON_TYPE_LAST],
                        GdkPixbuf               *mini_icon,
@@ -4560,7 +4756,13 @@ meta_frame_style_draw (MetaFrameStyle   
   meta_frame_style_draw_with_style (style, widget->style, widget,
                                     drawable, x_offset, y_offset,
                                     clip, fgeom, client_width, client_height,
-                                    title_layout, text_height,
+                                    title_layout, 
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+				    label,
+#endif				    
+#endif				    
+				    text_height,
                                     button_states, mini_icon, icon);
 }
 
@@ -4758,6 +4960,45 @@ meta_theme_get_current (void)
   return meta_current_theme;
 }
 
+
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+static void
+set_trusted_ops (MetaFrameStyle *style, MetaFrameFocus focus, MetaTheme *theme)
+{
+  if (style != NULL)
+    {
+      if (style->pieces[META_FRAME_PIECE_TITLE])
+	meta_draw_op_list_unref (style->pieces[META_FRAME_PIECE_TITLE]);
+      style->pieces[META_FRAME_PIECE_TITLE] = tsol_theme_trusted_label_ops_get (focus, theme);
+      style->pieces[META_FRAME_PIECE_TRUSTED_LABEL] = tsol_theme_trusted_title_ops_get (focus, theme);
+    }
+}
+
+static void 
+style_set_for_each (gpointer key,gpointer value,gpointer user_data)
+{
+ int i;
+ MetaFrameStyleSet *sset = (MetaFrameStyleSet *) value;
+ MetaTheme *theme = (MetaTheme *)user_data;
+
+ for (i=0;i < META_FRAME_RESIZE_LAST;i++)
+   {
+     set_trusted_ops(sset->normal_styles[i][META_FRAME_FOCUS_YES], META_FRAME_FOCUS_YES, theme);
+     set_trusted_ops(sset->normal_styles[i][META_FRAME_FOCUS_NO], META_FRAME_FOCUS_NO, theme);
+     set_trusted_ops(sset->shaded_styles[i][META_FRAME_FOCUS_YES], META_FRAME_FOCUS_YES, theme);
+     set_trusted_ops(sset->shaded_styles[i][META_FRAME_FOCUS_NO], META_FRAME_FOCUS_NO, theme);
+   }
+ 
+ set_trusted_ops(sset->maximized_styles[META_FRAME_FOCUS_YES], META_FRAME_FOCUS_YES, theme);
+ set_trusted_ops(sset->maximized_styles[META_FRAME_FOCUS_NO], META_FRAME_FOCUS_NO, theme);
+ set_trusted_ops(sset->maximized_and_shaded_styles[META_FRAME_FOCUS_YES], META_FRAME_FOCUS_YES, theme);
+ set_trusted_ops(sset->maximized_and_shaded_styles[META_FRAME_FOCUS_NO], META_FRAME_FOCUS_NO, theme);
+}
+
+#endif
+#endif
+
 void
 meta_theme_set_current (const char *name,
                         gboolean    force_reload)
@@ -4788,6 +5029,16 @@ meta_theme_set_current (const char *name
 
       meta_current_theme = new_theme;
 
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+      if (tsol_is_available ())
+	{
+	  shield_pixbuf = NULL; /* hack to display shield icon conditionally */
+	  g_hash_table_foreach (new_theme->style_sets_by_name, style_set_for_each, meta_current_theme);
+	}
+#endif      
+#endif      
+
       meta_topic (META_DEBUG_THEMES, "New theme is \"%s\"\n", meta_current_theme->name);
     }
 }
@@ -4845,10 +5096,15 @@ meta_theme_new (void)
   theme->quark_icon_height = g_quark_from_static_string ("icon_height");
   theme->quark_title_width = g_quark_from_static_string ("title_width");
   theme->quark_title_height = g_quark_from_static_string ("title_height");
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+  theme->quark_trusted_label_width = g_quark_from_static_string ("trusted_label_width");
+  theme->quark_trusted_label_height = g_quark_from_static_string ("trusted_label_height");
+#endif
+#endif
   return theme;
 }
 
-
 void
 meta_theme_free (MetaTheme *theme)
 {
@@ -5127,7 +5383,13 @@ meta_theme_draw_frame_with_style (MetaTh
                                   const MetaButtonLayout *button_layout,
                                   MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                                   GdkPixbuf              *mini_icon,
-                                  GdkPixbuf              *icon)
+                                  GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL		       
+				  ,MetaTrustedLabel	 *label
+#endif		       
+#endif		       
+				  )
 {
   MetaFrameGeometry fgeom;
   MetaFrameStyle *style;
@@ -5157,6 +5419,11 @@ meta_theme_draw_frame_with_style (MetaTh
                                     &fgeom,
                                     client_width, client_height,
                                     title_layout,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+				    label,
+#endif				    
+#endif				    
                                     text_height,
                                     button_states,
                                     mini_icon, icon);
@@ -5178,14 +5445,26 @@ meta_theme_draw_frame (MetaTheme        
                        const MetaButtonLayout *button_layout,
                        MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                        GdkPixbuf              *mini_icon,
-                       GdkPixbuf              *icon)
+                       GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL		       
+		       ,MetaTrustedLabel	      *label
+#endif		       
+#endif		       
+		      )
 {
   meta_theme_draw_frame_with_style (theme, widget->style, widget,
                                     drawable, clip, x_offset, y_offset, type,flags,
                                     client_width, client_height,
                                     title_layout, text_height,
                                     button_layout, button_states,
-                                    mini_icon, icon);
+                                    mini_icon, icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL			     
+				    ,label
+#endif									    
+#endif									    
+				    );
 }
 
 void
@@ -5204,7 +5483,13 @@ meta_theme_draw_frame_by_name (MetaTheme
                                const MetaButtonLayout *button_layout,
                                MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                                GdkPixbuf              *mini_icon,
-                               GdkPixbuf              *icon)
+                               GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL		       
+			      ,MetaTrustedLabel	      *label
+#endif		       
+#endif		       
+			       )
 {
   MetaFrameGeometry fgeom;
   MetaFrameStyle *style;
@@ -5231,6 +5516,11 @@ meta_theme_draw_frame_by_name (MetaTheme
                          &fgeom,
                          client_width, client_height,
                          title_layout,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL			 
+			 label,
+#endif			 
+#endif			 
                          text_height,
                          button_states,
                          mini_icon, icon);
@@ -5820,6 +6110,12 @@ meta_frame_piece_to_string (MetaFramePie
     {
     case META_FRAME_PIECE_ENTIRE_BACKGROUND:
       return "entire_background";
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL      
+    case META_FRAME_PIECE_TRUSTED_LABEL:
+      return "trusted_label";
+#endif      
+#endif      
     case META_FRAME_PIECE_TITLEBAR:
       return "titlebar";
     case META_FRAME_PIECE_TITLEBAR_MIDDLE:
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/theme.h metacity-2.27.1/src/ui/theme.h
--- ../metacity-2.27.1/src/ui/theme.h	2009-09-14 09:05:19.282621504 +0200
+++ metacity-2.27.1/src/ui/theme.h	2009-09-14 09:05:34.536364144 +0200
@@ -42,6 +42,11 @@ typedef struct _MetaFrameGeometry MetaFr
 typedef struct _MetaTheme MetaTheme;
 typedef struct _MetaPositionExprEnv MetaPositionExprEnv;
 typedef struct _MetaDrawInfo MetaDrawInfo;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+typedef struct _MetaTrustedLabel  MetaTrustedLabel;
+#endif
+#endif
 
 #define META_THEME_ERROR (g_quark_from_static_string ("meta-theme-error"))
 
@@ -227,6 +232,12 @@ typedef enum
   META_COLOR_SPEC_GTK,
   META_COLOR_SPEC_BLEND,
   META_COLOR_SPEC_SHADE
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  ,  
+  META_COLOR_SPEC_LABEL
+#endif    
+#endif    
 } MetaColorSpecType;
 
 typedef enum
@@ -250,6 +261,13 @@ struct _MetaColorSpec
     struct {
       GdkColor color;
     } basic;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+    struct {
+      gboolean dummy;
+    } label;
+#endif    
+#endif    
     struct {
       MetaGtkColorComponent component;
       GtkStateType state;
@@ -291,6 +309,11 @@ struct _MetaDrawInfo
   int title_layout_width;
   int title_layout_height;
   const MetaFrameGeometry *fgeom;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL 
+  MetaTrustedLabel *label;
+#endif 
+#endif 
 };
 
 /**
@@ -328,6 +351,13 @@ typedef enum
   META_DRAW_OP_LIST,
   /** tiled draw op list */
   META_DRAW_TILE
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+  ,
+  /* draw a string (used for trusted label) */
+  META_DRAW_TRUSTED_LABEL
+#endif
+#endif
 } MetaDrawType;
 
 typedef enum
@@ -556,6 +586,16 @@ struct _MetaDrawOp
       MetaDrawSpec *tile_height;
     } tile;
     
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL    
+    struct {
+      MetaColorSpec *color_spec;
+      char *x;
+      char *y;
+    } trusted_label;
+#endif    
+#endif    
+    
   } data;
 };
 
@@ -631,6 +671,12 @@ typedef enum
   
   /* entire frame */
   META_FRAME_PIECE_ENTIRE_BACKGROUND,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  /* Trusted Label area*/
+  META_FRAME_PIECE_TRUSTED_LABEL,
+#endif  
+#endif  
   /* entire titlebar background */
   META_FRAME_PIECE_TITLEBAR,
   /* portion of the titlebar background inside the titlebar
@@ -819,6 +865,12 @@ struct _MetaTheme
   GQuark quark_icon_height;
   GQuark quark_title_width;
   GQuark quark_title_height;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  GQuark quark_trusted_label_width;
+  GQuark quark_trusted_label_height;
+#endif  
+#endif  
 };
 
 struct _MetaPositionExprEnv
@@ -834,6 +886,12 @@ struct _MetaPositionExprEnv
   int bottom_height;
   int title_width;
   int title_height;
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL  
+  int trusted_label_width;
+  int trusted_label_height;
+#endif  
+#endif  
   int mini_icon_width;
   int mini_icon_height;
   int icon_width;
@@ -961,6 +1019,11 @@ void meta_frame_style_draw (MetaFrameSty
                             int                      client_width,
                             int                      client_height,
                             PangoLayout             *title_layout,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL			    
+			    MetaTrustedLabel	    *label,
+#endif			    
+#endif			    
                             int                      text_height,
                             MetaButtonState          button_states[META_BUTTON_TYPE_LAST],
                             GdkPixbuf               *mini_icon,
@@ -978,7 +1041,12 @@ void meta_frame_style_draw_with_style (M
                                        int                      client_width,
                                        int                      client_height,
                                        PangoLayout             *title_layout,
-                                       int                      text_height,
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL			    
+				       MetaTrustedLabel	    *label,
+#endif			    
+#endif			
+				       int                      text_height,
                                        MetaButtonState          button_states[META_BUTTON_TYPE_LAST],
                                        GdkPixbuf               *mini_icon,
                                        GdkPixbuf               *icon);
@@ -1031,7 +1099,13 @@ void meta_theme_draw_frame (MetaTheme   
                             const MetaButtonLayout *button_layout,
                             MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                             GdkPixbuf              *mini_icon,
-                            GdkPixbuf              *icon);
+                            GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+                           ,MetaTrustedLabel       *label
+#endif
+#endif
+                            );
 
 void meta_theme_draw_frame_by_name (MetaTheme              *theme,
                                     GtkWidget              *widget,
@@ -1048,7 +1122,13 @@ void meta_theme_draw_frame_by_name (Meta
                                     const MetaButtonLayout *button_layout,
                                     MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                                     GdkPixbuf              *mini_icon,
-                                    GdkPixbuf              *icon);
+                                    GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+				    ,MetaTrustedLabel       *label
+#endif
+#endif
+				    );
 
 void meta_theme_draw_frame_with_style (MetaTheme              *theme,
                                        GtkStyle               *style_gtk,
@@ -1066,7 +1146,13 @@ void meta_theme_draw_frame_with_style (M
                                        const MetaButtonLayout *button_layout,
                                        MetaButtonState         button_states[META_BUTTON_TYPE_LAST],
                                        GdkPixbuf              *mini_icon,
-                                       GdkPixbuf              *icon);
+                                       GdkPixbuf              *icon
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL
+				       ,MetaTrustedLabel       *label
+#endif
+#endif
+				       );
 
 void meta_theme_get_frame_borders (MetaTheme         *theme,
                                    MetaFrameType      type,
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/ui.c metacity-2.27.1/src/ui/ui.c
--- ../metacity-2.27.1/src/ui/ui.c	2009-09-14 09:05:19.283073587 +0200
+++ metacity-2.27.1/src/ui/ui.c	2009-09-14 09:05:34.536761212 +0200
@@ -22,6 +22,10 @@
  * 02111-1307, USA.
  */
 
+#include <config.h>
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
 #include "prefs.h"
 #include "ui.h"
 #include "frames.h"
@@ -963,6 +967,16 @@ meta_ui_get_drag_threshold (MetaUI *ui)
   return threshold;
 }
 
+#ifdef HAVE_XTSOL
+void
+meta_ui_set_frame_label (MetaUI     *ui,
+                         Window      xwindow,
+                         MetaTrustedLabel *label)
+{
+  meta_frames_set_label (ui->frames, xwindow, label);
+}
+#endif
+
 MetaUIDirection
 meta_ui_get_direction (void)
 {
diff -ruNp metacity-2.28.1.orig/src/core/main.c metacity-2.28.1/src/core/main.c
--- metacity-2.28.1.orig/src/core/main.c	2010-02-02 06:20:51.406777070 +0000
+++ metacity-2.28.1/src/core/main.c	2010-02-02 06:22:45.082185635 +0000
@@ -68,6 +68,7 @@
 #include <locale.h>
 #include <time.h>
 #include <unistd.h>
+#include "trusted.h"
 
 /**
  * The exit code we'll return to our parent process when we eventually die.
@@ -416,6 +417,10 @@ main (int argc, char **argv)
   guint i;
   GIOChannel *channel;
 
+  if (tsol_use_trusted_extensions () ) {
+       putenv ("GDK_NATIVE_WINDOWS=true");
+  }
+
   if (!g_thread_supported ())
     g_thread_init (NULL);
   
diff -ruN metacity-2.28.1.orig/src/core/prefs.c metacity-2.28.1/src/core/prefs.c
--- metacity-2.28.1.orig/src/core/prefs.c	2010-02-02 06:23:34.519993887 +0000
+++ metacity-2.28.1/src/core/prefs.c	2010-02-02 06:24:39.723889605 +0000
@@ -68,6 +68,10 @@
 #define KEY_WORKSPACE_NAME_DIRECTORY "/apps/metacity/workspace_names"
 #define KEY_WORKSPACE_NAME_PREFIX "/apps/metacity/workspace_names/name_"
 
+#ifdef HAVE_XTSOL
+#define KEY_WORKSPACE_LABEL_PREFIX "/apps/metacity/workspace_labels/ws_"
+#define KEY_WORKSPACE_ROLE_PREFIX "/apps/metacity/workspace_roles/ws_"
+#endif /* HAVE_XTSOL */
 
 #ifdef HAVE_GCONF
 static GConfClient *default_client = NULL;
diff -ruNp metacity-2.28.1.orig/src/include/ui.h metacity-2.28.1/src/include/ui.h
--- metacity-2.28.1.orig/src/include/ui.h	2010-02-02 06:25:53.374932836 +0000
+++ metacity-2.28.1/src/include/ui.h	2010-02-02 06:26:49.796360045 +0000
@@ -30,6 +30,7 @@
 #include <X11/Xutil.h>
 #include <glib.h>
 #include <gdk-pixbuf/gdk-pixbuf.h>
+#include "frames.h"
 
 /* This is between GTK_PRIORITY_RESIZE (+10) and GDK_PRIORITY_REDRAW (+20) */
 #define META_PRIORITY_RESIZE    (G_PRIORITY_HIGH_IDLE + 15)
